From 806c673be34e3395cea2fd0a1ac28ac813ed9c46 Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Wed, 27 May 2015 13:17:40 -0400
Subject: [PATCH] Add Vagrant configuration for SSSD

To set up a Vagrant development environment:
* Install the Vagrant packages for your development system
  * On Fedora 22 and later: 'dnf install vagrant-libvirt'
* Deploy the Vagrant box:
  * 'vagrant up'
* Build SSSD:
  * vagrant ssh -c "cd /vagrant; reconfig; chmake"

Vagrant can keep your development tree in-sync with the Vagrant box
by running 'vagrant rsync-auto' in a shell (this will continue to
run, monitoring for changes and syncing them as they are saved).
Alternately, it can be manually synced with 'vagrant rsync' at will.

More information:
http://fedoramagazine.org/running-vagrant-fedora-22/
---
 Vagrantfile                  | 77 ++++++++++++++++++++++++++++++++++++++++++++
 contrib/vagrant/bootstrap.sh | 21 ++++++++++++
 2 files changed, 98 insertions(+)
 create mode 100644 Vagrantfile
 create mode 100644 contrib/vagrant/bootstrap.sh

diff --git a/Vagrantfile b/Vagrantfile
new file mode 100644
index 0000000000000000000000000000000000000000..ae245c8cb2af7fd1fc28927e6963befc2f590066
--- /dev/null
+++ b/Vagrantfile
@@ -0,0 +1,77 @@
+# -*- mode: ruby -*-
+# vi: set ft=ruby :
+
+# Fedora blog on creating Vagrant files:
+# http://fedoramagazine.org/running-vagrant-fedora-22/
+
+# All Vagrant configuration is done below. The "2" in Vagrant.configure
+# configures the configuration version (we support older styles for
+# backwards compatibility). Please don't change it unless you know what
+# you're doing.
+Vagrant.configure(2) do |config|
+  # The most common configuration options are documented and commented below.
+  # For a complete reference, please see the online documentation at
+  # https://docs.vagrantup.com.
+
+  # Every Vagrant development environment requires a box. You can search for
+  # boxes at https://atlas.hashicorp.com/search.
+  config.vm.box = "fedora-22"
+  config.vm.box_url = "http://download.fedoraproject.org/pub/fedora/linux/releases/22/Cloud/x86_64/Images/Fedora-Cloud-Base-Vagrant-22-20150521.x86_64.vagrant-libvirt.box"
+
+  # Disable automatic box update checking. If you disable this, then
+  # boxes will only be checked for updates when the user runs
+  # `vagrant box outdated`. This is not recommended.
+  # config.vm.box_check_update = false
+
+  # Create a forwarded port mapping which allows access to a specific port
+  # within the machine from a port on the host machine. In the example below,
+  # accessing "localhost:8080" will access port 80 on the guest machine.
+  # config.vm.network "forwarded_port", guest: 80, host: 8080
+
+  # Create a private network, which allows host-only access to the machine
+  # using a specific IP.
+  # config.vm.network "private_network", ip: "192.168.33.10"
+
+  # Create a public network, which generally matched to bridged network.
+  # Bridged networks make the machine appear as another physical device on
+  # your network.
+  # config.vm.network "public_network"
+
+  # Share an additional folder to the guest VM. The first argument is
+  # the path on the host to the actual folder. The second argument is
+  # the path on the guest to mount the folder. And the optional third
+  # argument is a set of non-required options.
+  # config.vm.synced_folder "../data", "/vagrant_data"
+
+  # Provider-specific configuration so you can fine-tune various
+  # backing providers for Vagrant. These expose provider-specific options.
+  # Example for VirtualBox:
+  #
+  # config.vm.provider "virtualbox" do |vb|
+  #   # Display the VirtualBox GUI when booting the machine
+  #   vb.gui = true
+  #
+  #   # Customize the amount of memory on the VM:
+  #   vb.memory = "1024"
+  # end
+  #
+  # View the documentation for the provider you are using for more
+  # information on available options.
+
+  # Define a Vagrant Push strategy for pushing to Atlas. Other push strategies
+  # such as FTP and Heroku are also available. See the documentation at
+  # https://docs.vagrantup.com/v2/push/atlas.html for more information.
+  # config.push.define "atlas" do |push|
+  #   push.app = "YOUR_ATLAS_USERNAME/YOUR_APPLICATION_NAME"
+  # end
+
+  # Enable provisioning with a shell script. Additional provisioners such as
+  # Puppet, Chef, Ansible, Salt, and Docker are also available. Please see the
+  # documentation for more information about their specific syntax and use.
+  # config.vm.provision "shell", inline: <<-SHELL
+  #   sudo apt-get update
+  #   sudo apt-get install -y apache2
+  # SHELL
+
+  config.vm.provision :shell, path: "contrib/vagrant/bootstrap.sh"
+end
diff --git a/contrib/vagrant/bootstrap.sh b/contrib/vagrant/bootstrap.sh
new file mode 100644
index 0000000000000000000000000000000000000000..c887c1a0e27faefa5db597e1acd4f21cb6b3aa24
--- /dev/null
+++ b/contrib/vagrant/bootstrap.sh
@@ -0,0 +1,21 @@
+#!/bin/bash -x
+
+sed -e "s/@PACKAGE_NAME@/sssd/" \
+    -e "s/@PRERELEASE_VERSION@//" \
+    -e "s/@PACKAGE_VERSION@/0/" \
+    /vagrant/contrib/sssd.spec.in > /vagrant/contrib/sssd_vagrant.spec
+
+dnf clean metadata
+dnf install -y @buildsys-build realmd sssd adcli polkit oddjob-mkhomedir
+dnf builddep -y /vagrant/contrib/sssd_vagrant.spec
+
+source /usr/share/doc/git/contrib/completion/git-prompt.sh
+
+cat << EOF >> /home/vagrant/.bashrc
+source /usr/share/doc/git/contrib/completion/git-prompt.sh
+export GIT_PS1_SHOWDIRTYSTATE=1
+export PS1='[\u@\h:\W\$(__git_ps1 " (%s)")]\$\[\e[0m\] '
+
+. /vagrant/contrib/fedora/bashrc_sssd
+
+EOF
-- 
2.4.1